/* 
 * CSE142, 98 Autumn
 * Homework 4
 Jon Bumgardner 
 jond8@
 9827565
 *
 */

/* There's a landscape in the background...

*/

#include "GP142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	7

/*color of letter on buttons*/
#define SELECTED_COLOR   YELLOW	 
#define UNSELECTED_COLOW BLACK

#define MAX_PRECIP_EVENTS	500
	/*This is the total number of drops possible at one time.*/

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define ALIEN 3

/*if you add new types of percip, you may need to change this*/
#define MAX_PRECIP_TYPES 2

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button (doesn't say which one yet)*/
#define DIRT 2
	/*The above means you clicked in the dirt area */

/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally*/
void  ClearAllPrecipitation(int  precip_type[500], int x);


/*render (draw) all the precipitation*/
void DrawAllPrecipitationArry(int precip_type[500], int bottom_x[500], int bottom_y[500], int color_type[500], int c);
void DrawAllPrecipitation(int current_precip, int x, int y, int current_color);

void DrawLandscape();

/*draw one drop*/
void DrawPrecipColumn(int precip_type, int bottom_x, int bottom_y, int color);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);
void Draw_alien (int x, int y, int c);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant, int *v);

/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/
int main(void)
{
  int quit = FALSE,i,x,c,s=0,v=0/* counter*/;
  int mouse_x, mouse_y;
  char key_hit;

  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;

  /* 
   * The next itens tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  int precip_type[500];
  int color_type[500];
  int bottom_x[500];
  int bottom_y[500];
  /*int  precip_color;*/
 
  int current_precip=NONE; 
  int current_color=NONE; /*what to draw next */
  int active=FALSE;
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;

  /*what kind of click was there?*/
  int mouse_click;

  int event; /*the most recent GP142 event*/

  time_t t; /*needed only when initializing a random number generator*/

  /*
   * INITIALIZATIONS
   */

	precip_type[500] = NONE; 
	color_type[500] = NONE;
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.
		*/

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  DrawLandscape();
  DrawButtons(current_precip, current_color);	  /* Show the buttons...*/ 
  ClearAllPrecipitation(precip_type, 0);


  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */

	  c=1;
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);


	if (mouse_click == BUTTON) {
		if(current_color != NONE && current_precip != NONE){
		current_color = NONE;
		current_precip = NONE;


		}
			/* a button has been clicked.  Call a function to handle it*/

		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag, &v);
		c=0;

		if (clear_flag)
			ClearAllPrecipitation(precip_type, x);
		if(current_precip==ALIEN){
			current_color = 13;
			mouse_x = -70;
			mouse_y = GP142_YMAX;
			c=1;
		}

	}    if((mouse_click != DIRT)
		&& 
		 (current_precip != NONE) && (current_color != NONE) && (c==1))
		{
		active=TRUE;
		DrawAllPrecipitation(current_precip, mouse_x, mouse_y, current_color);
		if (precip_type[500] == NONE)
		x=-1;
		x++;
		precip_type[x] = current_precip ;
		color_type[x] = current_color;
		bottom_x[x] = mouse_x; 
		bottom_y[x] = mouse_y;	}		

      break;

    case GP142_PERIODIC:
		for (i=0; i<=x; i++){
		if(precip_type[i]==RAIN)
			bottom_y[i]-=5;
		if(bottom_y[i]<TOP_OF_DIRT)
			bottom_y[i]=GP142_XMAX;   			

		if(precip_type[i]==SNOW){
			bottom_y[i]--;
		if(bottom_y[i]<TOP_OF_DIRT)
			bottom_y[i]=GP142_XMAX; 
		if(0==bottom_y[i]%2)
			bottom_x[i]+=2;
		else
			bottom_x[i]-=3;}


		if (precip_type[i] == ALIEN){
			bottom_y[i]--;
			bottom_x[i]+=3;
			
		}

	  }



      	/*Some time has passed, 
		so make all the precipitation a little lower*/
		/*and change the sun's position a little bit*/
		sun_x --;
		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;
				/* over a long period of time, the sun will set.*/
		}

      break;

    default:

      break;
	
    }  /*end switch */

     /*Redraw everything */

    DrawLandscape(sun_x, sun_y);
    DrawButtons(current_precip, current_color);
	if((GP142_YMAX-s)>TOP_OF_DIRT-20 && v==1){
		s+=3;
		v=1;}
	else if((GP142_YMAX-s)<=TOP_OF_DIRT-20  || v==2){
		s-=3;
		v=2;}

	GP142_rectangleXY(ICE_BLUE, -20 , GP142_YMAX,
	-50, GP142_YMAX-s, FILL);

		if(v==0 || v==1){
		GP142_circleXY(BROWN, -35, TOP_OF_DIRT-35, 20);
		GP142_circleXY(BROWN, -35, TOP_OF_DIRT-13, 17);
		GP142_circleXY(WHITE, -29, (TOP_OF_DIRT-13), 5);
		GP142_circleXY(WHITE, -41, (TOP_OF_DIRT-13), 5);
		GP142_circleXY(BLUE, -29, (TOP_OF_DIRT-13), 2);
		GP142_circleXY(BLUE, -41, (TOP_OF_DIRT-13), 2);
		GP142_circleXY(BLACK, -35, (TOP_OF_DIRT-20), 3);
		GP142_circleXY(PINK, -35, (TOP_OF_DIRT-29), 4);
		GP142_circleXY(BROWN, -45, TOP_OF_DIRT-55, 5);
		GP142_circleXY(BROWN, -25, TOP_OF_DIRT-55, 5);
		GP142_circleXY(BROWN, -18, (TOP_OF_DIRT-13), 5);
		GP142_circleXY(BROWN, -52, (TOP_OF_DIRT-13), 5);
		}
		if(v==2){
		GP142_circleXY(NAVY_BLUE, -35, (GP142_YMAX-s)-22, 20);
		GP142_circleXY(BLUE, -35, GP142_YMAX-s, 17);
		GP142_circleXY(PINK, -29, (GP142_YMAX-s), 5);
		GP142_circleXY(PINK, -41, (GP142_YMAX-s), 5);
		GP142_circleXY(RED, -29, (GP142_YMAX-s), 2);
		GP142_circleXY(RED, -41, (GP142_YMAX-s), 2);
		GP142_circleXY(BLACK, -35, (GP142_YMAX-s)-7, 3);
		GP142_circleXY(PURPLE, -35, (GP142_YMAX-s)-16, 4);
		GP142_circleXY(BLUE, -45, (GP142_YMAX-s)-42, 5);
		GP142_circleXY(BLUE, -25, (GP142_YMAX-s)-42, 5);
		GP142_circleXY(BLUE, -18, (GP142_YMAX-s), 5);
		GP142_circleXY(BLUE, -52, (GP142_YMAX-s), 5);
		{
		}
		}
	
	if(active==TRUE)
    DrawAllPrecipitationArry(precip_type, bottom_x, bottom_y, color_type, x);

  }  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased.
	*/
void  ClearAllPrecipitation(int  precip_type[500], int x)
{
	int i;
	for (i=0; i<=x; i++)
	precip_type[i] = NONE;
}



#define RAINDROP_WIDTH 3

void DrawRainDrop (int x, int y, int color) {
	GP142_circleXY(color, x, y, RAINDROP_WIDTH);
	
 

}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

void DrawSnowDrop (int x, int y, int color) {
	  GP142_triangleXY(color,
		   x , y,
		   x-SNOWDROP_WIDTH, y-SNOWDROP_HEIGHT,
		   x-SNOWDROP_WIDTH, y,
		   FILL);
/*something missing here? */
}

void Draw_alien (int x, int y, int c){

	int i;


		GP142_circleXY(NAVY_BLUE, x, y, 20);
		GP142_triangleXY(NAVY_BLUE,
		   x , y,
		   x, y-20,
		   x-40, y-15,
		   FILL);
		GP142_triangleXY(NAVY_BLUE,
		   x , y,
		   x, y-20,
		   x+40, y-15,
		   FILL);
		GP142_rectangleXY(5, x-20 , y,
			x+20, y-20, FILL);
		GP142_circleXY(CHALK, x, y+7, 6);
		GP142_circleXY(BLACK, x+2, y+7, 1);
		GP142_circleXY(BLACK, x-2, y+7, 1);
		GP142_lineXY(WHITE, x+5,y-23, x-5, y-23, 3);
		for(c=0; c<11; c++){
				GP142_pixelXY(PURPLE, (x-20)+(4*c), y-10 );
				GP142_pixelXY(BLUE, (x-20)+(4*c), y-9 );}
		i++;
		if(0==i%2)
			GP142_lineXY(ORANGE, x+5,y-23, x-5, y-23, 3);

}	


void DrawAllPrecipitation(int current_precip, int x, int y, int current_color)
{

	if (y >= TOP_OF_DIRT - 20) {
		switch (current_precip) {
		case RAIN:
			DrawRainDrop (x, y, current_color);
			break;
		case SNOW:
			DrawSnowDrop (x, y, current_color);
			break;
		case ALIEN:
			Draw_alien (x,y,1);
			break;

		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
			
		}
}


void DrawAllPrecipitationArry(int precip_type[500], int bottom_x[500], int bottom_y[500], int color_type[500], int c)
{
	int i;
	for (i=0; i<=c; i++){

	if (bottom_y[i] >= TOP_OF_DIRT - 20) {
		switch (precip_type[i]) {
		case RAIN:
			DrawRainDrop (bottom_x[i], bottom_y[i], color_type[i]);
			break;
		case SNOW:
			DrawSnowDrop (bottom_x[i], bottom_y[i], color_type[i]);
			break;
		case ALIEN:
			Draw_alien (bottom_x[i], bottom_y[i], c);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
		}	
		}
}



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}


void DrawLandscape(int sun_x, int sun_y)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;


  /* Draw the sky first */
  GP142_rectangleXY(DUSTY_PLUM, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  /* Draw the sun */
  GP142_circleXY(CHALK, sun_x, sun_y , 20);
  GP142_circleXY(DUSTY_PLUM, sun_x-6, sun_y , 15);

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(OLIVE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");

  
  /*Draw the mountains */
  GP142_triangleXY(MED_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(LT_GRAY,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);

  /* Trees*/

  GP142_triangleXY(SEA_GREEN,
		   0 , (TOP_OF_DIRT-10),
		   80, (TOP_OF_DIRT-10),
		   40, (2 * GP142_YMAX)/9,
		   FILL);
  GP142_rectangleXY(BROWN, 35 , (TOP_OF_DIRT-10),
	  45, (TOP_OF_DIRT-20), FILL);


} /*end DrawLandscape */


/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather, int *v)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  
  case 2:
    *current_color = WHITE;
    break;
  case 3:
    *current_color = BLUE;
    break;
  
  case 4:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */

  case 5:
    *current_precip = ALIEN;

    break; 

   case 6:
    *v= 1;

    break; 

  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");
	
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

    i -= BUTTON_HEIGHT;
    GP142_printfXY(BLACK, text_offset, i, font_size, "Sighting");
	
	    i -= BUTTON_HEIGHT;
    GP142_printfXY(BLACK, text_offset, i, font_size, "Abduction");


}


void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}